import React, { useMemo, useRef, useEffect } from 'react';
import { Consumer } from '@storybook/api';
import { U as UPDATE_STORY_CONTEXT } from './types.esm.js';

const ManagerContainer = props => {
    const { active, api, route } = props;
    const channel = useMemo(() => api.getChannel(), [api]);
    const storyRef = useRef('');
    useEffect(() => {
        const ATTACH_DOCS_PAGE = `attach_docs_page_${route}`;
        const sendMessage = () => {
            const story = api.getCurrentStoryData();
            channel.emit(ATTACH_DOCS_PAGE, { active, storyId: story === null || story === void 0 ? void 0 : story.id });
        };
        const wrapper = document.getElementById('storybook-preview-wrapper');
        const updateDOM = () => {
            sendMessage();
            if (wrapper) {
                wrapper.removeAttribute('hidden');
            }
        };
        updateDOM();
    }, [active, api, route, channel]);
    return (React.createElement(Consumer, null, ({ state }) => {
        if (state.storyId !== storyRef.current) {
            storyRef.current = state.storyId;
            channel.emit(UPDATE_STORY_CONTEXT, state);
        }
        return null;
    }));
};

export { ManagerContainer };
