'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var api = require('@storybook/api');
var types = require('./types.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

const ManagerContainer = props => {
    const { active, api: api$1, route } = props;
    const channel = React.useMemo(() => api$1.getChannel(), [api$1]);
    const storyRef = React.useRef('');
    React.useEffect(() => {
        const ATTACH_DOCS_PAGE = `attach_docs_page_${route}`;
        const sendMessage = () => {
            const story = api$1.getCurrentStoryData();
            channel.emit(ATTACH_DOCS_PAGE, { active, storyId: story === null || story === void 0 ? void 0 : story.id });
        };
        const wrapper = document.getElementById('storybook-preview-wrapper');
        const updateDOM = () => {
            sendMessage();
            if (wrapper) {
                wrapper.removeAttribute('hidden');
            }
        };
        updateDOM();
    }, [active, api$1, route, channel]);
    return (React__default['default'].createElement(api.Consumer, null, ({ state }) => {
        if (state.storyId !== storyRef.current) {
            storyRef.current = state.storyId;
            channel.emit(types.UPDATE_STORY_CONTEXT, state);
        }
        return null;
    }));
};

exports.ManagerContainer = ManagerContainer;
