import { Channel } from '@storybook/addons';
import { ConfigApi } from '@storybook/client-api';
export * from './types';
/**
 * function returning the global options
 * parameters and decorators
 */
export declare const getGlobalOptions: () => any;
/**
 * function returning the current story id
 */
export declare const getCurrentStoryId: () => string | undefined;
/**
 * React hook hook that tracks the changes to the current story and returns it's id
 * @returns a story id as a React hook, when the the current story changes, will call back
 */
export declare const useStoryId: () => string;
export interface CurrentSelection {
    /**
     * current story id
     */
    storyId: string;
    /**
     * current document id - its the title
     */
    docId: string;
    /**
     * story name
     */
    name: string;
    /**
     * story parameters
     */
    parameters: any;
}
/**
 * React hook hook that tracks the changes to the current story and returns the data
 * @returns a story id , document id, name and parameters
 */
export declare const useCurrentData: () => CurrentSelection;
export interface StorybookContext {
    configApi: ConfigApi;
    storyStore: any;
    channel: Channel;
    clientApi: any;
    selectedKind: string;
    selectedStory: string;
    parameters: any;
    storyId: string;
}
/**
 * React hook - returns a context similar (but not identical) that can be used as an input attribute to `<DocsContainer />`
 */
export declare const useContext: () => StorybookContext;
