'use strict';

var loaderUtils = require('loader-utils');

module.exports.default = async function () {
    const options = loaderUtils.getOptions(this) || {};
    const { filenames } = options;
    const callback = this.async();
    
    const code = ` 
const React = require('react');
const ReactDOM = require('react-dom');
${filenames.map((file, index) => `const pageConfig_${index} = require("${file}");`).join('/n')}
const { BroadcastChannel } = require('broadcast-channel');

const attachPage = (pageConfig) => {

  const ATTACH_DOCS_PAGE = \`attach_docs_page_\${pageConfig.title}\`;
  const channel = new BroadcastChannel(ATTACH_DOCS_PAGE);
  
  interface MessageProps {
    id: string;
    active: boolean;
    storyId: string;
  }
  channel.onmessage = ({ id, active, storyId }: MessageProps) => {
    var node = document.getElementById(id);
    if (!node) {
      node = document.createElement('div');
      node.setAttribute('id', id);
      document.body.appendChild(node);
    }
    if (active) {
      node.removeAttribute('hidden');
      ReactDOM.render(pageConfig.render({ active, storyId }),
        document.getElementById(id),
      );
    } else {
      node.setAttribute('hidden', 'true');
      ReactDOM.unmountComponentAtNode(node);
    }
  };
};

${filenames.map((file, index) => `attachPage(pageConfig_${index});`).join('/n')}
`;
  return callback(null, code);
};
