import { ReactNode } from 'react';
/**
 *
 * Custom page default export
 * example:
 *
 * ```
 * import React from 'react';

export default {
  key: 'custom',
  title: 'Simple Page',
  render: ({ active }) => active ? <div><h1>Simple docs page</h1></div> : null,
}```
 */
export interface CustomPageRenderFnParams {
    /**
     * is the page active (visible) or not (hidden)
     */
    active: boolean;
}
export declare type CustomPageRenderFn = (params: CustomPageRenderFnParams) => ReactNode;
export interface CustomPageDef {
    /**
     * key used for router navigation
     */
    key: string;
    /**
     * title of the page's tab
     */
    title: string;
    /**
     * react render function.
     *
     */
    render: CustomPageRenderFn;
}
export declare const UPDATE_STORY_CONTEXT = "update_story_context";
